/*
  KMZ80 common header
  by Mamiya
*/

#ifndef KMZ80_H_
#define KMZ80_H_

#include "kmtypes.h"
#include "kmevent.h"
#ifdef __cplusplus
extern "C" {
#endif

enum {
	REGID_B,
	REGID_C,
	REGID_D,
	REGID_E,
	REGID_H,
	REGID_L,
	REGID_F,
	REGID_A,
	REGID_IXL,
	REGID_IXH,
	REGID_IYL,
	REGID_IYH,
	REGID_R,
	REGID_R7,
	REGID_I,
	REGID_IFF1,
	REGID_IFF2,
	REGID_IMODE,
	REGID_NMIREQ,
	REGID_INTREQ,
	REGID_HALTED,
	REGID_M1CYCLE,
	REGID_MEMCYCLE,
	REGID_IOCYCLE,
	REGID_STATE,
	REGID_FDMG,
	REGID_MAX,
	REGID_REGS8SIZE = ((REGID_MAX + (sizeof(int) - 1)) & ~(sizeof(int) - 1))
};

typedef struct KMZ80_CONTEXT_TAG KMZ80_CONTEXT;
struct KMZ80_CONTEXT_TAG {
	Uint8 regs8[REGID_REGS8SIZE];
	Uint32 sp;
	Uint32 pc;
	/* WX^ */
	Uint32 saf;
	Uint32 sbc;
	Uint32 sde;
	Uint32 shl;
	/* e|tOWX^(Öق̃L[tO) */
	Uint32 t_fl;
	/* e|f[^[WX^(Öق35tO) */
	Uint32 t_dx;
	/* ܂ł͕ۑׂ */
	/* e|vOJE^ */
	Uint32 t_pc;
	/* e|IyhWX^ */
	Uint32 t_op;
	/* e|AhXWX^ */
	Uint32 t_ad;
	/* TCNJE^ */
	Uint32 cycle;
	/* IyR[he[u */
	void *opt;
	/* IyR[hCBe[u */
	void *optcb;
	/* IyR[hEDe[u */
	void *opted;
	/* ǉTCNe[u */
	void *cyt;
	/* R800[y[W(y[WuCN̊mFp) */
	Uint32 mempage;
	/* pr荞݃xN^ */
	Uint32 vector[5];
	/* RSTѐ{AhX */
	Uint32 rstbase;
	/* ǉtO */
	/*   bit0: Öق̃L[L */
	/*   bit1: 荞ݗvNA */
	Uint32 exflag;
	/* `R[obN */
	Uint32 (*sysmemfetch)(KMZ80_CONTEXT *context);
	Uint32 (*sysmemread)(KMZ80_CONTEXT *context, Uint32 a);
	void (*sysmemwrite)(KMZ80_CONTEXT *context, Uint32 a, Uint32 d);
	/* [U[f[^[|C^ */
	void *user;
	/* [U[`R[obN */
	Uint32 (*memread)(void *u, Uint32 a);
	void (*memwrite)(void *u, Uint32 a, Uint32 d);
	Uint32 (*ioread)(void *u, Uint32 a);
	void (*iowrite)(void *u, Uint32 a, Uint32 d);
	Uint32 (*busread)(void *u, Uint32 mode);
	Uint32 (*checkbreak)(void *u, KMZ80_CONTEXT *context);
	Uint32 (*patchedfe)(void *u, KMZ80_CONTEXT *context);
	/* [U[`Cxg^C} */
	KMEVENT *kmevent;
};

void kmz80_reset(KMZ80_CONTEXT *context);
void kmr800_reset(KMZ80_CONTEXT *context);
void kmdmg_reset(KMZ80_CONTEXT *context);
Uint32 kmz80_exec(KMZ80_CONTEXT *context, Uint32 cycle);

#ifdef __cplusplus
}
#endif
#endif
